#include <stdio.h>
#include <string.h>
#include "CUnit/Basic.h"
#include "sudoku.h"

static FILE * testinput = NULL;

int InitSuite(){  
	return 0;  
}   
      
int EndSuite(){  
	return 0;
}

//regular input ,has solution
void test1(){

	testinput = fopen("input1", "r");
        CU_ASSERT(solSudoku(testinput, "1") == 1);
        fclose(testinput);

}

//regular input form but no solution
void test2(){

	testinput = fopen("input2", "r");
	CU_ASSERT(solSudoku(testinput, "2") == 0);
	fclose(testinput);
}

//input lead to bug
void test3(){

	testinput = fopen("input3", "r");
	CU_ASSERT(solSudoku(testinput, "3") == 1);
	fclose(testinput);
}

void test4(){

	testinput = fopen("input4", "r");
	CU_ASSERT(solSudoku(testinput, "4") == -1);
	fclose(testinput);
}

int main(){

	CU_pSuite pSuite = NULL;
	if (CUE_SUCCESS != CU_initialize_registry())
		return CU_get_error();
	
	pSuite = CU_add_suite("testSuite", InitSuite, EndSuite);
	if (NULL == pSuite){
		CU_cleanup_registry();
		return CU_get_error();
	}

	if(NULL == CU_add_test(pSuite, "Test1", test1) ||  
	   NULL == CU_add_test(pSuite, "Test2", test2) ||
	   NULL == CU_add_test(pSuite, "Test3", test3) ||
	   NULL == CU_add_test(pSuite, "Test4", test4)){
		CU_cleanup_registry();
		return CU_get_error();
	}

	CU_basic_set_mode(CU_BRM_VERBOSE);
	CU_basic_run_tests();
	CU_cleanup_registry();
	return CU_get_error();
}
